<?php

namespace Swarming\SubscribePro\Model;

use SubscribePro\Service\Subscription\Subscription as PlatformSubscription;
use Swarming\SubscribePro\Api\Data\ProductInterface;
use Swarming\SubscribePro\Api\Data\SubscriptionInterface;

/**
 * @codeCoverageIgnore
 */
class Subscription extends PlatformSubscription implements SubscriptionInterface
{
    /**
     * @return \Swarming\SubscribePro\Api\Data\ProductInterface|null
     */
    public function getProduct()
    {
        return $this->getData(self::PRODUCT);
    }

    /**
     * @param \Swarming\SubscribePro\Api\Data\ProductInterface $product
     * @return $this
     */
    public function setProduct(ProductInterface $product)
    {
        return $this->setData(self::PRODUCT, $product);
    }

    /**
     * @return mixed[]
     */
    public function getProductOption()
    {
        $platformSpecificFields = $this->getPlatformSpecificFields();
        return $platformSpecificFields[self::PLATFORM_FIELD_KEY][self::PRODUCT_OPTION] ?? [];
    }

    /**
     * @param array $productOptions
     * @return $this
     */
    public function setProductOption(array $productOptions)
    {
        $platformSpecificFields = $this->getPlatformSpecificFields();
        $platformSpecificFields[self::PLATFORM_FIELD_KEY][self::PRODUCT_OPTION] = $productOptions;
        return $this->setPlatformSpecificFields($platformSpecificFields);
    }

    /**
     * @return false|mixed[]|string
     */
    public function getUserDefinedFields()
    {
        return json_encode(parent::getUserDefinedFields());
    }
}
